package com.performix.module.integration.messagebus;

import java.util.Properties;

import javax.annotation.Resource;
import javax.ejb.EJBException;
import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageConsumer;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.jms.Topic;
import javax.naming.Context;
import javax.naming.InitialContext;

import org.apache.commons.logging.Log;

import com.performix.mesutil.logger.MesLogger;
import com.performix.module.configuration.MesEnvironment;

public class JmsHelper {

	private static final String JAVA_JMS_XA = "java:/JmsXA";
	private static JmsHelper myInstance = null;
	private Context context = null;
	private ConnectionFactory cf = null;
	private static final Log log = MesLogger.getLogger(JmsHelper.class);

	private final String xMESTopicSystemEventMsg="java:jboss/exported/jms/topic/xMESTopicSystemEventMsg";
	private final String xMesTopicHistory="java:jboss/exported/jms/topic/xMesTopicHistory";
	
	private JmsHelper() {
		
	}

	public static JmsHelper getInstance() {
		if(myInstance == null) {
			myInstance = new JmsHelper();
		}
		return myInstance;
	}

	public boolean sendMessage(String message, String destination) {
		boolean status = true;
		if(context == null || cf == null) {
			status = false;
		}
		String destinationTopic = MesEnvironment.getValue("MESSAGING", destination);
		if ( destinationTopic == null ) {
			log.warn("Unable to read jmsTopic value for attribute: "+ destinationTopic + " from mes.xml. Taking default as xMesTopicEvent.");
			destinationTopic = "xMesTopicEvent" ;
		}
		 log.info("before message topic is send---------------------------------------------"+destinationTopic);
		try {
			context=new InitialContext();
			ConnectionFactory connectionFactory = (ConnectionFactory) context.lookup(JAVA_JMS_XA);
			Destination destination1 = null;
			if(destinationTopic.equalsIgnoreCase("xMesTopicHistory")){
				
				destination1=(Destination) context.lookup(xMesTopicHistory);
				log.info("in--------xMesTopicHistory--------------------------------------"+destinationTopic);
				
			}else if(destinationTopic.equalsIgnoreCase("xMESTopicSystemEventMsg")){
				
				destination1=(Destination) context.lookup(xMESTopicSystemEventMsg);
				log.info("in--------xMESTopicSystemEventMsg--------------------------------------"+destinationTopic);
			}
			
			context.close();
			Connection connection = connectionFactory.createConnection("user1","user123");
			Session session = connection.createSession(false,Session.AUTO_ACKNOWLEDGE);
			MessageProducer messageProducer = session.createProducer(destination1);
			connection.start();
			TextMessage message1 = session.createTextMessage();
			message1.setText(message);
			messageProducer.send(destination1,message1);
			log.info("message sent "+destinationTopic+"-------------------------------------------------"+message);
        } catch (Exception e) {
            e.printStackTrace();
            log.info("in catch block---------------------------------------------------"+destinationTopic);
        }
		
		
		return status;
	}
	
	
	 

	

}
